import speech_recognition as sr
import math
import time
import sys
import openai
import pygame
from gtts import gTTS
pygame.mixer.init()
import pyttsx3
from langdetect import detect

#model_to_use="text-davinci-003" # most capable
#model_to_use="text-curie-001"
#model_to_use="text-babbage-001"
model_to_use="text-ada-001" # lowest token cost
r = sr.Recognizer()
#openai.api_key="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"
#openai.api_key="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"
openai.api_key="sk-m6b5oZ"

def chatGPT(query):
	response = openai.Completion.create(
		model=model_to_use,
		prompt=query,
		temperature=0,
		max_tokens=1000
		)
	return str.strip(response['choices'][0]['text']), response['usage']['total_tokens']
def detect_language(text):
    return detect(text)

def detect_wake_word():
    r = sr.Recognizer()
    with sr.Microphone() as source:
        r.adjust_for_ambient_noise(source)
        print("Say 'Jarvis' to activate the assistant.")
        audio = r.listen(source)

    try:
        text = r.recognize_google(audio)
        print(text)
        if "jarvis" in text.lower():
            return True
        else:
            return False
    except sr.UnknownValueError:
        return False
    except sr.RequestError as e:
        print("Could not request results from Google Speech Recognition service; {0}".format(e))
        return False
def main():
    print('LED is ON while button is pressed (Ctrl-C for exit).')
    while True:
        text = input("Enter a sentence: ")
        language = detect_language(text)
        print("Detected Language:", language)
        if detect_wake_word():
            with sr.Microphone() as source:
                r.adjust_for_ambient_noise(source)
                print("Say something!")
                audio = r.listen(source)
                print("Recognizing Now .... ")
                try:
                    # using google speech recognition
                    #command=str(r.recognize_google(audio))
                    text = r.recognize_google(audio,language=language)
                    command=str(text)
                    print(command)
                except Exception as e:
                    print("Error: " + str(e))
                    command=""
                print("Google Speech Recognition thinks you said " + command)
                query=command
                (res, usage) = chatGPT(query)
                print(res)
                tts = gTTS(text=res, lang=language)
                tts.save("good.mp3")
                pygame.mixer.music.load("good.mp3")
                pygame.mixer.music.play()
                #espeak.synth(res)
            
                        


if __name__ == '__main__':
    main()
